#include <iostream>
#include <qcoreapplication.h>
#include <qstring.h>
#include <qsettings.h>

using namespace std;

void show_opts(void);
int get_setting(QString key);
int save_setting(QString key, QString value);
bool removeSetting(QString key);

QSettings settings("PCBSD");

int main( int argc, char ** argv )
{
    QCoreApplication a( argc, argv);

    QString Tmp = a.argv()[1];
  
    // Read a setting 
    if ( Tmp == "set")
    {
       if ( a.argc() != 4) return 1;
       return save_setting(a.argv()[2], a.argv()[3]);
    }
    else if (Tmp == "get" )
    {
       if ( a.argc() != 3) return 1;
       return get_setting(a.argv()[2]);
    }
    else if(Tmp == "rem")
    {
       if ( a.argc() != 3) return 1;
       return removeSetting(a.argv()[2]);
    }
    else
    {
      show_opts();
      return 1;
    }
}

// Find the value for <key> and return it
int get_setting(QString key)
{
 QString value;
 
 value = settings.value(key, QString()).toString();
 cout << value.toStdString();

 return 0; 

}

// Set the value for <key>
int save_setting(QString key, QString value)
{
 settings.setValue(key, value );
 return 0;
}

bool removeSetting(QString key)
{
  settings.remove(key);
  return true;
}

void show_opts(void)
{
  cout << "pbreg Version 1.0\n--------\n" << "pbreg <command> <key> <value>\n\n"; 
  cout << "Commands:\n" << "  get - Gets a variable from the registry\n";
  cout << "  set - Sets a variable specified by <value> in the registry\n";
  cout << "  rem - Removes a variable from the registry\n\n";
  cout << "Examples:\n\n" << " # pbreg get /PC-BSD/Version\n";
  cout << " # pbreg set /PC-BSD/Version 1.0\n"; 
  cout << " # pbreg rem /PC-BSD/Version\n";
}
